package com.logicbig.example;

import com.logicbig.example.service.OrderService;
import com.logicbig.example.service.impl.OrderServiceImpl1;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.AnnotationConfigApplicationContext;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;


@Configuration
public class SetterBasedDI {

    @Bean
    public OrderService orderServiceByProvider1 () {
        return new OrderServiceImpl1();
    }

    @Bean
    public OrderServiceClient createClient () {
        return new OrderServiceClient();
    }

    public static void main (String... strings) {
        AnnotationConfigApplicationContext context = new AnnotationConfigApplicationContext(
                            SetterBasedDI.class);
        OrderServiceClient bean = context.getBean(OrderServiceClient.class);
        bean.showPendingOrderDetails();
    }

    
    private static class OrderServiceClient {

        private OrderService orderService;

        @Autowired
        public void setOrderService (OrderService orderService) {
            this.orderService = orderService;
        }

        public void showPendingOrderDetails () {
            System.out.println(orderService.getOrderDetails("100"));
        }
    }
}